Index: uspace/lib/libblock/libblock.h
===================================================================
--- uspace/lib/libblock/libblock.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libblock/libblock.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -60,4 +60,6 @@
 #define BLOCK_FLAGS_NOREAD	1
 
+typedef uint64_t bn_t;	/**< Block number type. */
+
 typedef struct block {
 	/** Mutex protecting the reference count. */
@@ -108,5 +110,4 @@
 
 extern int block_get_bsize(dev_handle_t, size_t *);
-extern int block_get_nblocks(dev_handle_t, bn_t *);
 extern int block_read_direct(dev_handle_t, bn_t, size_t, void *);
 extern int block_write_direct(dev_handle_t, bn_t, size_t, const void *);
Index: uspace/lib/libc/arch/mips32eb/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/mips32eb/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libc/arch/mips32eb/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -35,6 +35,5 @@
 ARCH_SOURCES += arch/$(UARCH)/src/syscall.c \
 	arch/$(UARCH)/src/fibril.S \
-	arch/$(UARCH)/src/tls.c \
-	arch/$(UARCH)/src/stacktrace.S
+	arch/$(UARCH)/src/tls.c
 
 GCC_CFLAGS += -mips3
Index: uspace/lib/libc/generic/io/io.c
===================================================================
--- uspace/lib/libc/generic/io/io.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libc/generic/io/io.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -554,15 +554,4 @@
 }
 
-int ftell(FILE *stream)
-{
-	off_t rc = lseek(stream->fd, 0, SEEK_CUR);
-	if (rc == (off_t) (-1)) {
-		/* errno has been set by lseek. */
-		return -1;
-	}
-
-	return rc;
-}
-
 void rewind(FILE *stream)
 {
@@ -595,10 +584,4 @@
 }
 
-void clearerr(FILE *stream)
-{
-	stream->eof = false;
-	stream->error = false;
-}
-
 int fphone(FILE *stream)
 {
Index: uspace/lib/libc/generic/stacktrace.c
===================================================================
--- uspace/lib/libc/generic/stacktrace.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libc/generic/stacktrace.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -39,4 +39,6 @@
 void stack_trace_fp_pc(uintptr_t fp, uintptr_t pc)
 {
+	printf("Printing stack trace:\n");
+	printf("=====================\n");
 	while (frame_pointer_validate(fp)) {
 		printf("%p: %p()\n", fp, pc);
@@ -44,4 +46,5 @@
 		fp = frame_pointer_prev(fp);
 	}
+	printf("=====================\n");
 }
 
Index: uspace/lib/libc/include/assert.h
===================================================================
--- uspace/lib/libc/include/assert.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libc/include/assert.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -51,12 +51,5 @@
 
 #ifndef NDEBUG
-#	define assert(expr) \
-		do { \
-			if (!(expr)) { \
-				printf("Assertion failed (%s) at file '%s', " \
-				    "line %d.\n", #expr, __FILE__, __LINE__); \
-				abort(); \
-			} \
-		} while (0)
+#	define assert(expr) if (!(expr)) { printf("Assertion failed (%s) at file '%s', line %d.\n", #expr, __FILE__, __LINE__); abort();}
 #else
 #	define assert(expr)
Index: uspace/lib/libc/include/ipc/bd.h
===================================================================
--- uspace/lib/libc/include/ipc/bd.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libc/include/ipc/bd.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -40,5 +40,4 @@
 typedef enum {
 	BD_GET_BLOCK_SIZE = IPC_FIRST_USER_METHOD,
-	BD_GET_NUM_BLOCKS,
 	BD_READ_BLOCKS,
 	BD_WRITE_BLOCKS
Index: uspace/lib/libc/include/sys/types.h
===================================================================
--- uspace/lib/libc/include/sys/types.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libc/include/sys/types.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -40,5 +40,4 @@
 typedef long off_t;
 typedef int mode_t;
-typedef uint64_t bn_t;	/**< Block number type. */
 
 typedef int32_t wchar_t;
Index: uspace/srv/bd/ata_bd/ata_bd.c
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/srv/bd/ata_bd/ata_bd.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -296,8 +296,4 @@
 			ipc_answer_1(callid, EOK, block_size);
 			continue;
-		case BD_GET_NUM_BLOCKS:
-			ipc_answer_2(callid, EOK, LOWER32(disk[disk_id].blocks),
-			    UPPER32(disk[disk_id].blocks));
-			continue;
 		default:
 			retval = EINVAL;
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -56,5 +56,4 @@
 
 static const size_t block_size = 512;
-static bn_t num_blocks;
 static FILE *img;
 
@@ -100,5 +99,4 @@
 {
 	int rc;
-	long img_size;
 
 	rc = devmap_driver_register(NAME, file_bd_connection);
@@ -111,17 +109,4 @@
 	if (img == NULL)
 		return EINVAL;
-
-	if (fseek(img, 0, SEEK_END) != 0) {
-		fclose(img);
-		return EIO;
-	}
-
-	img_size = ftell(img);
-	if (img_size < 0) {
-		fclose(img);
-		return EIO;
-	}
-
-	num_blocks = img_size / block_size;
 
 	fibril_mutex_initialize(&dev_lock);
@@ -189,8 +174,4 @@
 			ipc_answer_1(callid, EOK, block_size);
 			continue;
-		case BD_GET_NUM_BLOCKS:
-			ipc_answer_2(callid, EOK, LOWER32(num_blocks),
-			    UPPER32(num_blocks));
-			continue;
 		default:
 			retval = EINVAL;
@@ -205,15 +186,8 @@
 {
 	size_t n_rd;
-	int rc;
 
 	fibril_mutex_lock(&dev_lock);
 
-	clearerr(img);
-	rc = fseek(img, ba * block_size, SEEK_SET);
-	if (rc < 0) {
-		fibril_mutex_unlock(&dev_lock);
-		return EIO;
-	}
-
+	fseek(img, ba * block_size, SEEK_SET);
 	n_rd = fread(buf, block_size, cnt, img);
 
@@ -235,16 +209,9 @@
 {
 	size_t n_wr;
-	int rc;
 
 	fibril_mutex_lock(&dev_lock);
 
-	clearerr(img);
-	rc = fseek(img, ba * block_size, SEEK_SET);
-	if (rc < 0) {
-		fibril_mutex_unlock(&dev_lock);
-		return EIO;
-	}
-
-	n_wr = fwrite(buf, block_size, cnt, img);
+	fseek(img, ba * block_size, SEEK_SET);
+	n_wr = fread(buf, block_size, cnt, img);
 
 	if (ferror(img) || n_wr < cnt) {
@@ -253,9 +220,4 @@
 	}
 
-	if (fflush(img) != 0) {
-		fibril_mutex_unlock(&dev_lock);
-		return EIO;
-	}
-
 	fibril_mutex_unlock(&dev_lock);
 
Index: uspace/srv/bd/gxe_bd/gxe_bd.c
===================================================================
--- uspace/srv/bd/gxe_bd/gxe_bd.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/srv/bd/gxe_bd/gxe_bd.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -234,7 +234,4 @@
 			ipc_answer_1(callid, EOK, block_size);
 			continue;
-		case BD_GET_NUM_BLOCKS:
-			retval = ENOTSUP;
-			break;
 		default:
 			retval = EINVAL;
Index: uspace/srv/bd/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -463,8 +463,5 @@
 			ipc_answer_1(callid, EOK, block_size);
 			continue;
-		case BD_GET_NUM_BLOCKS:
-			ipc_answer_2(callid, EOK, LOWER32(part->length),
-			    UPPER32(part->length));
-			continue;
+
 		default:
 			retval = EINVAL;
Index: uspace/srv/bd/rd/rd.c
===================================================================
--- uspace/srv/bd/rd/rd.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/srv/bd/rd/rd.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -153,8 +153,4 @@
 			ipc_answer_1(callid, EOK, block_size);
 			continue;
-		case BD_GET_NUM_BLOCKS:
-			ipc_answer_2(callid, EOK, LOWER32(rd_size / block_size),
-			    UPPER32(rd_size / block_size));
-			continue;
 		default:
 			/*
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/srv/vfs/vfs_ops.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -900,5 +900,4 @@
 		}
 		newpos = size + off;
-		file->pos = newpos;
 		fibril_mutex_unlock(&file->lock);
 		ipc_answer_1(rid, EOK, newpos);
